# Music admins - Music admins can force music, force stop and more.
# You can add more admins, just keep the syntax!
MusicAdmins = ["STEAM_0:1:26397964", "STEAM_0:1:7589873", "STEAM_ID_LAN"]

# For more configuration see:
# "../cfg/eventscripts/music/music.cfg"

## No more editing in this script!
import es
import popuplib
import esamlib
import cmdlib
import playerlib
from usermsg import motd
from urllib2 import urlopen

import psyco
psyco.full()
    
ReplayArtist = {}
ReplayTrack = {}
ReplayURL = {}
NowPlayingArtist = {}
NowPlayingTrack = {}
MusicForcement = {}
ForceMusicArtist = {}
ForceMusicTrack = {}
ForceMusicURL = {}

variables = [
        ["music_version","v5.0.01CheeTaH-Public","The Music Menu script version.",1],
        ["music_database","html-cheetah.webs.com/music/musicdb.html","The Music Menu music database.",1],
        ["music_not_admin_msg", "You ain't no admin!", "message to non admins, when they try to use a admin command",0],
        ["music_check_for_updates", "1", "If this is enabled, then the script will check for updates on script load and map start",0],
        ["music_listening", "You are now listening to:", "message to give players, when they have chosen a song",0],
        ["music_stopped_msg", "You stopped listening to music!", "message to give players, when they have stop the music",0],
        ["music_replaying_msg", "You are now replaying:", "message to give players, when they replay a song",0],
        ["music_replaying_msg_unavailable", "It doesn't seems like you've listened to anything yet!", "message to give players, when they fail to replay a song",0],
        ["music_now_playing_msg", "You are currently listening to:", "message to give players on !nowplaying",0],
        ["music_now_playing_msg_nothing", "You aren't listening to anything currently!", "message to give players on !nowplaying, when they aren't listening to anything",0],
    ]

CexecCMDs = ["!music", "!stop", "!replay", "!nowplaying", "!musicforce", "!musicforceall", "!musicforceperson"]


class MusicMaster():
    def info(self): # runs on script load and map change
        global musicDB
        for var in variables:
            vari = es.ServerVar(var[0],var[1],var[2])
            vari.set(var[1])
            if (var[3] == 1):
                vari.makepublic()
        es.mexec("../cfg/eventscripts/music/music.cfg")
        musicDB = urlopen(str("http://%s"%es.ServerVar("music_database"))).read().replace("\r","").split("\n")
        if (es.ServerVar("music_check_for_updates")):
            CheckMusicVersion()
        
    def menu(self): # runs on script load and map change
        musicartist = popuplib.easymenu("musicmenu_artist_select",None,self.menuhandle)
        musicartist.settitle("Artist Selection")
        ArtistUsed = {}
        for artists in musicDB:
            if artists.startswith("www."):
                artist = artists.split("|")
                if (len(artist) == 3):
                    Artist = artist[1]
                    if Artist not in ArtistUsed:
                        ArtistUsed[Artist] = "Used"
                        musicartist.addoption(Artist,Artist)
                        self.musicmenu(Artist)
            
    def menuhandle(self,userid,choice,popupname): # when an artist is picked
        popuplib.send("musicmenu_artist_%s"%choice,userid)
        
    def musicmenu(self,artist): # put the artists in the !music-menu (runs when "def menu" runs)
        musicsong = popuplib.easymenu("musicmenu_artist_%s"%artist,None,self.artisthandle)
        musicsong.settitle("Song Selection: \n %s" %(artist))
        for song in musicDB:
            songi = song.split("|")
            if (len(songi) == 3):
                if (songi[1] == artist):
                    musicsong.addoption(songi,songi[2])
        musicsong.submenu(0,"musicmenu_artist_select")
        
    def artisthandle(self,userid,choice,popupname): # when a song is picked
        if userid not in MusicForcement:
            MusicForcement[userid] = 0
        MusicForcementValue = MusicForcement[userid]
        if (MusicForcementValue == 0):
            ReplayArtist[userid] = choice[1]
            ReplayTrack[userid] = choice[2]
            ReplayURL[userid] = choice[0]
            MusicTell(userid, es.ServerVar("music_listening"))
            MusicTellSong(userid, choice[1], choice[2])
            playURL(userid, choice[0])
            NowPlayingArtist[userid] = choice[1]
            NowPlayingTrack[userid] = choice[2]
        if (MusicForcementValue == 1):
            ReplayArtist[userid] = choice[1]
            ReplayTrack[userid] = choice[2]
            ReplayURL[userid] = choice[0]
            es.msg("#multi","\x05[Music] %s forced all to listen to:" %(es.getplayername(userid)))
            MusicTellSong("all", choice[1], choice[2])
            Players = playerlib.getUseridList('#human')
            for Player in Players:
                playURL(Player, choice[0])
                NowPlayingArtist[userid] = choice[1]
                NowPlayingTrack[userid] = choice[2]
        if (MusicForcementValue == 2):
            CreateForceMenu(userid, choice[0], choice[1], choice[2])
def playURL(userid,URL): # plays a URL
    motd(userid,2,"CheeTaH - Music Menu %s"%es.ServerVar("music_version"),"about:blank",False)
    if (URL.lower() != "stop"):
        motd(userid,2,"CheeTaH - Music Menu %s"%es.ServerVar("music_version"),URL,False)

        
MM = MusicMaster()

def load():
    MM.info()
    MM.menu()
    cmdlib.registerClientCommand("!music", client_cmd_music, "console command to open music menu")
    cmdlib.registerClientCommand("!stop", client_cmd_stop, "console command to stop music")
    cmdlib.registerClientCommand("!replay", client_cmd_replay, "console command to stop music")
    cmdlib.registerClientCommand("!nowplaying", client_cmd_nowplaying, "console command to stop music")
    cmdlib.registerClientCommand("!musicforce", client_cmd_musicforce, "console command to open forcemusic-selection-menu")
    cmdlib.registerClientCommand("!musicforceall", client_cmd_musicforceall, "console command to open the music list with forcing all")
    cmdlib.registerClientCommand("!musicforceperson", client_cmd_musicforceperson, "console command to open music list with forcing a single person")
    
    global MusicForceSelection
    MusicForceSelection = popuplib.easymenu("MusicForceSelection",None,MusicForceSelectionChoice)
    MusicForceSelection.settitle("Forcing Method:")
    MusicForceSelection.addoption("!music", "Force me (!Music)")
    MusicForceSelection.addoption("!musicforceall", "Force me (!MusicForceAll)")
    MusicForceSelection.addoption("!musicforceperson", "Force person (!MusicForcePerson)")

def unload():
    for CMD in CexecCMDs:
        cmdlib.unregisterClientCommand(CMD)
                    
def es_map_start(ev):
    MM.info()
    MM.menu()

def player_disconnect(ev):
    userid = int(ev['userid'])
    if userid in ReplayArtist:
        del ReplayArtist[userid]
        del ReplayTrack[userid]
        del ReplayURL[userid]
    if userid in NowPlayingArtist:
        del NowPlayingArtist[userid]
        del NowPlayingTrack[userid]
    if userid in MusicForcement:
        del MusicForcement[userid]
    if userid in ForceMusicArtist:
        del ForceMusicArtist[userid]
        del ForceMusicTrack[userid]
        del ForceMusicURL[userid]

def client_cmd_music(player, args=0):
    popuplib.send("musicmenu_artist_select",player)
    MusicForcement[player] = 0

def client_cmd_stop(player, args=0):
    playURL(player, "stop")
    MusicTell(player, es.ServerVar("music_stopped_msg"))
    if userid in player:
        del NowPlayingArtist[player]
        del NowPlayingTrack[player]

def client_cmd_replay(player, args=0):
    player = int(player)
    if player in ReplayArtist:
        MusicTell(player, es.ServerVar("music_replaying_msg"))
        MusicTellSong(player, ReplayArtist[player], ReplayTrack[player])
        NowPlayingArtist[player] = ReplayArtist[player]
        NowPlayingTrack[player] = ReplayTrack[player]
        playURL(player, ReplayURL[player])
    else:
        MusicTell(player, es.ServerVar("music_replaying_msg_unavailable"))

def client_cmd_nowplaying(player, args=0):
    Player = int(player)
    if Player in NowPlayingArtist:
        MusicTell(player, es.ServerVar("music_now_playing_msg"))
        MusicTellSong(player, NowPlayingArtist[Player], NowPlayingTrack[Player])
    else:
        MusicTell(player, es.ServerVar("music_now_playing_msg_nothing"))

def client_cmd_musicforce(player, args=0):
    if (PlayerIsMusicAdmin(player)):
        MusicForceSelection.send(player)
    else:
        MusicTell(player, es.ServerVar("music_not_admin_msg"))

def client_cmd_musicforceall(player, args=0):
    if (PlayerIsMusicAdmin(player)):
        popuplib.send("musicmenu_artist_select",player)
        MusicForcement[player] = 1
    else:
        MusicForcement[player] = 0
        MusicTell(player, es.ServerVar("music_not_admin_msg"))

def client_cmd_musicforceperson(player, args=0):
    if (PlayerIsMusicAdmin(player)):
        popuplib.send("musicmenu_artist_select",player)
        MusicForcement[player] = 2
    else:
        MusicForcement[player] = 0
        MusicTell(player, es.ServerVar("music_not_admin_msg"))
    
def MusicForceSelectionChoice(userid,choice,popupname):
    es.cexec(userid, choice)
    
def MusicForcePersonBlock(userid,choice,popupname):
    if (choice != "UpdateList"):
        Players = playerlib.getUseridList('#human')
        for Player in Players:
            if (Player == userid):
                MusicTell(Player, "You forced %s to listen to:" %(es.getplayername(choice)))
            elif (Player == choice):
                MusicTell(Player, "%s forced you to listen to:" %(es.getplayername(userid)))
            else:
                MusicTell(Player, "%s forced %s to listen to:" %(es.getplayername(userid), es.getplayername(choice)))
        playURL(choice, ForceMusicURL[userid])
        MusicTellSong("all", ForceMusicArtist[userid], ForceMusicTrack[userid])
    CreateForceMenu(userid, ForceMusicURL[userid], ForceMusicArtist[userid], ForceMusicTrack[userid])
    
def CreateForceMenu(Player, URL, Artist, Track):
    ForceMusicArtist[Player] = Artist
    ForceMusicTrack[Player] = Track
    ForceMusicURL[Player] = URL
    if popuplib.exists('MusicForcePersonMenu'):
        popuplib.delete('MusicForcePersonMenu')
    global MusicForcePersonMenu
    MusicForcePersonMenu = popuplib.easymenu('MusicForcePersonMenu',None, MusicForcePersonBlock)
    MusicForcePersonMenu.settitle("Music %s" %str(es.ServerVar("music_version")).replace("CheeTaH-Public", "").replace("v", ""))
    MusicForcePersonMenu.setdescription("Choose a player to force to: \n%s - %s \n%s" %(Artist, Track, URL))
    MusicForcePersonMenu.addoption('UpdateList', '--- Update List ---')
    Players = playerlib.getUseridList('#all')
    Players = sorted(Players, key=lambda player: es.getplayername(player))
    if (Players):
        MusicForcePersonMenu.addoption('----------', ' ', 0)
    else:
        MusicForcePersonMenu.addoption('----------', 'No players found', 0)
    for Player in Players:
        MusicForcePersonMenu.addoption(Player, '%s (%s)' %(es.getplayername(Player), Player))
    MusicForcePersonMenu.send(Player)
    
def player_say(ev):
    text = str(ev["text"]).lower()
    userid = int(ev["userid"])
    if (text in CexecCMDs):
        es.cexec(userid, text)
        
def PlayerIsMusicAdmin(userid):
    if not es.exists('userid', userid):
        return False
    steamid = es.getplayersteamid(userid)
    if steamid in MusicAdmins:
        return True
    return False
    
def MusicTell(TellPerson, Message):
    if not es.exists('userid', TellPerson):
        return
    es.tell(TellPerson, "#multi", "\x05[Music] #default%s" %(Message))
    
def MusicTellSong(TellPerson, artist, track):
    TellMSG = "\x05%s#default - \x05%s" %(artist, track)
    if (str(TellPerson).lower() == "all"):
        es.msg("#multi", TellMSG)
    else:
        if not es.exists('userid', TellPerson):
            return
        es.tell(TellPerson, "#multi", TellMSG)
def CheckMusicVersion():
    musicCurrentVersion = str(es.ServerVar("music_version")).replace("CheeTaH-Public", "").replace("v", "")
    musicWebsiteVersion = esamlib.getAddon('musicpython').currentversion
    es.dbgmsg(0, "----------------------")
    if (musicCurrentVersion == musicWebsiteVersion):
        es.dbgmsg(0, "Music version matches! (%s)" %(musicCurrentVersion))
    else:
        es.dbgmsg(0, "Server version: %s. Newest version: %s." %(musicCurrentVersion, musicWebsiteVersion))
        es.dbgmsg(0, "Music version does not match the newest one. You can get the newest one here:")
        es.dbgmsg(0, "www.addons.eventscripts.com/addons/view/musicpython")
    es.dbgmsg(0, "----------------------")